SystemOrganization addCategory: #OLPCPrepare!
SystemOrganization addCategory: #'OLPCPrepare-Test'!

Object subclass: #ResourceToMethodSerializer
	instanceVariableNames: 'directory methodDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLPCPrepare'!

!ResourceToMethodSerializer class methodsFor: 'as yet unclassified' stamp: 'test 11/16/2007 00:19'!
createMethodsInClass: class forDataOfFilesinDirectory: pathToDirectory 
	| instance |
	instance := self on: pathToDirectory.
	instance fillMethodDictionaryFromFormsOfFiles: instance filePaths.
	instance methodSources do: [:each | class compile: each]! !

!ResourceToMethodSerializer class methodsFor: 'as yet unclassified' stamp: 'rkrk 11/15/2007 18:28'!
on: aPathString 
	| directory |
	directory := FileDirectory on: aPathString.
	directory exists ifFalse: [self error: 'No directory ' , directory pathName , ' exists!!'].
	^ self onDirectory: directory! !

!ResourceToMethodSerializer class methodsFor: 'as yet unclassified' stamp: 'rkrk 11/15/2007 18:17'!
onDirectory: aDirectory 

	^ self new 
		directory: aDirectory;
		yourself! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'test 11/15/2007 22:38'!
atKey: aSymbol putMethod: aMethodString 
	methodDictionary at: aSymbol put: aMethodString! !

!ResourceToMethodSerializer methodsFor: 'creation' stamp: 'rkrk 11/15/2007 15:56'!
createMethod: aString inClass: aClass 
	
	aClass compile: aString! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'rkrk 11/15/2007 18:09'!
directory
	^ directory! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'rkrk 11/15/2007 18:12'!
directory: anObject
	directory := anObject! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'test 11/16/2007 00:25'!
filePaths

	^ self directory fileNames 
		select: [:each | self isWantedFile: each]
		thenCollect: [:each | self directory fullNameFor: each]! !

!ResourceToMethodSerializer methodsFor: 'creation' stamp: 'rkrk 11/16/2007 01:03'!
fillMethodDictionaryFromFormsOfFiles: fileNames 
	| form key fileName methodBody |
	fileNames do: 
			[:each | 
			"self halt."
			form := ImageReadWriter formFromFileNamed: each.
			methodBody := '^ ' , form storeString.
			fileName := (each findBetweenSubStrs: FileDirectory slash) last asSymbol.
			key := self methodNameFromeFileName: fileName.
			self atKey: key putMethod: methodBody]! !

!ResourceToMethodSerializer methodsFor: 'initialize-release' stamp: 'test 11/15/2007 22:38'!
initialize
	super initialize.
	methodDictionary := Dictionary new! !

!ResourceToMethodSerializer methodsFor: 'testing' stamp: 'rkrk 11/16/2007 00:36'!
isWantedFile: aString
	
	^ (aString first  = $.) not! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'test 11/15/2007 22:40'!
methodDictionary
	^ methodDictionary! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'test 11/15/2007 22:38'!
methodDictionary: anObject
	methodDictionary := anObject! !

!ResourceToMethodSerializer methodsFor: 'converting' stamp: 'rkrk 11/16/2007 01:00'!
methodNameFromeFileName: aString 
	
	^ (aString findBetweenSubStrs: '.') first! !

!ResourceToMethodSerializer methodsFor: 'accessing' stamp: 'rkrk 11/16/2007 00:48'!
methodSources
	
	| result |
	result := OrderedCollection new.
	self methodDictionary keysAndValuesDo: [:methodName :methodBody |
		result add: methodName asString , Character cr asString , methodBody].
	^ result! !

!ResourceToMethodSerializer methodsFor: 'creation' stamp: 'rkrk 11/15/2007 22:31'!
methodWithSelector: aSymbol andBody: aString 
	
	^ aSymbol , Character cr asString , aString ! !

TestCase subclass: #ResourceToMethodSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLPCPrepare-Test'!

!ResourceToMethodSerializerTest methodsFor: 'helper' stamp: 'test 11/15/2007 22:39'!
assertFormsOfSUT: sut equal: expectedForms 
	| resultForms |
	"self halt".
	resultForms := sut methodDictionary values collect: [:each | Form readFrom: each].
	^ expectedForms with: resultForms
		do: [:expectedForm :resultForm | self assert: expectedForm bits = resultForm bits]! !

!ResourceToMethodSerializerTest methodsFor: 'helper' stamp: 'rkrk 11/15/2007 20:16'!
createClass

	^ Object
		subclass: #SomeTestClass
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.! !

!ResourceToMethodSerializerTest methodsFor: 'helper' stamp: 'rkrk 11/15/2007 21:34'!
defaultForm
	^ Morph new imageForm ! !

!ResourceToMethodSerializerTest methodsFor: 'helper' stamp: 'test 11/15/2007 23:54'!
inDirectory: aPathString createFilesNamed: fileNames andDo: aBlock 
	| directory forms form |
	directory := FileDirectory on: aPathString.
	forms := OrderedCollection new.
	[directory assureExistence.
	fileNames do: [:each | 
		form := self defaultForm.
		forms add: form.
		self writeForm: form asPNGOn: (directory forceNewFileNamed: each)].
	aBlock value: forms] ensure: [directory recursiveDelete]! !

!ResourceToMethodSerializerTest methodsFor: 'helper' stamp: 'rkrk 11/15/2007 13:22'!
removeClass: class

	class removeFromSystem! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'rkrk 11/15/2007 21:48'!
someDir
	^ SmalltalkImage current imagePath , FileDirectory slash , 'test'! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'rkrk 11/15/2007 18:13'!
testConstructOnDirectory

	| sut path expected |
	path := SmalltalkImage current imagePath.
	self
		shouldnt: [sut := ResourceToMethodSerializer on: path]
		raise: Error.
	expected := FileDirectory on: path.
	self assert: expected pathName = sut directory pathName! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'rkrk 11/15/2007 18:18'!
testConstructOnNonExistingDirectory

	| path |
	path := SmalltalkImage current imagePath , 'xyzasdbcs23234984'.
	self
		should: [ResourceToMethodSerializer on: path]
		raise: Error.! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'test 11/16/2007 00:10'!
testCreateImageForms
	| sut fileNames dir |
	fileNames := #('test1.png' 'test2.png' ).
	dir := self someDir.
	self 
		inDirectory: dir
		createFilesNamed: fileNames
		andDo: 
			[:expectedForms | 
			sut := ResourceToMethodSerializer on: dir.
			sut fillMethodDictionaryFromFormsOfFiles: sut filePaths.
			self assertFormsOfSUT: sut equal: expectedForms]! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'rkrk 11/15/2007 21:49'!
testCreateMethod

	| methodName source method expected class sut |
	sut := ResourceToMethodSerializer new.
	methodName := #someMethod.
	source := '^ 123'.
	method := methodName asString , Character cr asString , source.
	[class := self createClass.
	sut createMethod: method inClass: class.
	expected := class methodDict at: methodName ifAbsent: [self assert: false].
	self assert: expected getSource = method.
	] ensure: [self removeClass: class].! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'test 11/16/2007 00:05'!
testCreateMethodStrings
	| sut methodName methodBody expected |
	sut := ResourceToMethodSerializer new.
	methodName := 'm1'.
	methodBody := '^xyz'.
	expected := methodName , Character cr asString , methodBody.
	sut methodDictionary at: methodName asSymbol put: methodBody.
	self assert: sut methodSources size = 1.
	self assert: sut methodSources first = expected.! !

!ResourceToMethodSerializerTest methodsFor: 'testing' stamp: 'rkrk 11/16/2007 01:00'!
testWellFormedMethodNameFromFileName

	| sut fileName expected |
	sut := ResourceToMethodSerializer new.
	fileName := 'bla-bla.jupp'.
	expected := 'bla-bla'.
	self assert: (expected = (sut methodNameFromeFileName: fileName))! !

!ResourceToMethodSerializerTest methodsFor: 'helper' stamp: 'test 11/15/2007 23:01'!
writeForm: aForm asPNGOn: aMultiByteFileStream 
	PNGReadWriter putForm: aForm onStream: aMultiByteFileStream! !
